function [InfDS,bAccept,meanb,tpOld] = drawbGeneral6_opt3(InfDS,meanb,yesMean,upperb,lowerb,useMultN,tpOld,freeIC,isBlock1Only,setScaleb)
%#codegen
Sigmae = InfDS.Sigmae;
iSigmae= eye(size(Sigmae)) / Sigmae;


if (useMultN==1)
    InfDS.N = 4;
else
    InfDS.N=1;
end

if isempty(InfDS.bAdaptParams)
    low1 = 1;
    high1 = 2;
    by1 = .1;
else	
    low1 = InfDS.bAdaptParams(1);
    high1 = InfDS.bAdaptParams(2);
    by1 = InfDS.bAdaptParams(3);
end


if isBlock1Only
Nb = 1;
else
Nb = InfDS.Nb;
end


MUb = reshape(InfDS.b(:,1:Nb)',Nb*InfDS.Nsubj,1);
oldb = InfDS.b; 
bTemp = zeros(InfDS.Nsubj,Nb);
s  = zeros(InfDS.Nsubj,InfDS.N);

propden_new = zeros(InfDS.Nsubj,1);
propden_new1 = zeros(InfDS.Nsubj,InfDS.N);
propden_old = zeros(InfDS.Nsubj,1);
tpNew1 = zeros(InfDS.Nsubj,InfDS.N);
newb1 = zeros(InfDS.Nsubj,Nb,InfDS.N);



xtild = InfDS.Xtild;
dXtilddthetafAll = InfDS.dXtildthetafAll;
dXtilddthetafAll2 = InfDS.dXtildthetafAll2;


        s(:,:) = reshape(randsample(low1:by1:high1,InfDS.N*InfDS.Nsubj,true),InfDS.Nsubj,InfDS.N); %
        s = sqrt(s);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Generate new b

OMEGAb = InfDS.OMEGAb;
scaleb = InfDS.scaleb;

for i=1:InfDS.Nsubj	

    OMEGAi = scaleb*OMEGAb(1+(i-1)*Nb:i*Nb,1+(i-1)*Nb:i*Nb);
	[cOMEGAb0,r] = chol(OMEGAi);
    if r > 0
        cOMEGAb0 = diag(diag(sqrt(OMEGAi)));
    end;              
    for q=1:InfDS.N
		cOMEGAb = s(i,q)*cOMEGAb0;
		normtmp = randn(Nb,1);
        tempi = (MUb((1+(i-1)*Nb):(i*Nb)) + cOMEGAb*normtmp)'; %mgd(1,InfDS.Nx,MUx2',OMEGAx)';
        tempi = round2(tempi,10e-4);
        
        for jj = 1:Nb
        if ((max(tempi(jj)) < upperb(jj) && min(tempi) > lowerb(jj)) || isnan(upperb(jj)))
            newb1(i,jj,q) = tempi(jj);
        else
            newb1(i,jj,q) = MUb((jj+(i-1)*Nb));
        end
        end
		propden_new1(i,q) = -0.5* sum(normtmp.^2) - sum(log(diag(cOMEGAb)));
    end
end%end of subject loop

for q = 1:InfDS.N    
	InfDS1 = InfDS;
    InfDS1.N = 1;
	InfDS1.b(:,1:Nb) = reshape(newb1(:,1:Nb,q),InfDS.Nsubj,Nb);
	InfDS1 = getXtildIC3(InfDS1, 0 ,freeIC);
	[tpNew] = ekfContinuous10(InfDS1);
	tpNew1(:,q) = tpNew;	
end


[tpNew,tpidx]=max(tpNew1,[],2);
for i = 1:InfDS.Nsubj
	bTemp(i,:) = reshape(newb1(i,1:Nb,tpidx(i)),1,Nb);
	propden_new(i) = propden_new1(i,tpidx(i));
end
InfDS.b(:,1:Nb) = bTemp;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Ntmp = InfDS.N;
InfDS.N = 1;
InfDS = getXtildIC3(InfDS, 1, freeIC);
InfDS.N = Ntmp;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Proposal for oldb

for i=1:InfDS.Nsubj
    
    T = length(InfDS.timeDiscrete{i});
    
    temp = zeros(size(Nb,Nb));
    %dt = InfDS.Deltat{i};%InfDS.fulldt{i};
    for t=1:(T-1)%No last time point                                        
        dfdbt = InfDS.Z(:,1:Nb)'*InfDS.dXtildthetafAll{i}(:,(1+(t-1)*InfDS.NxState):(t*InfDS.NxState))*InfDS.Lambda';
        temp = temp+dfdbt*iSigmae*dfdbt';                    
    end %end of t loop
        
    OMEGAb(1+(i-1)*Nb:i*Nb,1+(i-1)*Nb:i*Nb) = inv(inv(InfDS.Sigmab(1:Nb,1:Nb)) + temp);    
end

bdtmp = oldb(:,1:Nb)-InfDS.b(:,1:Nb);
avgScalingb = zeros(InfDS.Nsubj,1);

for i=1:InfDS.Nsubj	    

    OMEGAi = s(i,tpidx(i))*InfDS.scaleb*OMEGAb(1+(i-1)*Nb:i*Nb,1+(i-1)*Nb:i*Nb);    
    avgScalingb(i) =s(i,tpidx(i));
    [cOMEGAb,r] = chol(OMEGAi);
        if r > 0
            cOMEGAb = diag(diag(sqrt(OMEGAi)));
        end;     

		normtmp = reshape(bdtmp(i,:),1,Nb) /cOMEGAb;               
		propden_old(i) = -0.5* sum(normtmp.^2) - sum(log(diag(cOMEGAb)));

end%end of subject loop
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Evaluate MH ratio and which set to keep%
%totalb = totalb+InfDS.Nsubj;
index = 1:InfDS.Nsubj;

tp= 0 + rand(InfDS.Nsubj,1) * (1-0); %sample from unif(0,1)
tp1=min(1.0,exp(tpNew+propden_old-tpOld-propden_new));
idx = tp<=tp1&~isnan(tpNew);
indexKept = index(idx);
cindexKept = index(~idx);

Nkept = length(indexKept);


bAccept = Nkept/InfDS.Nsubj;

InfDS.bacc = InfDS.bacc + idx;

if Nkept  > 0    
    tpOld(indexKept) = tpNew(indexKept);
    if setScaleb==1
    avgScalingb = avgScalingb(indexKept);
    InfDS.scaleb = InfDS.scaleb*quantile(avgScalingb,1-InfDS.setAccept);%mean(avgScalingb);
    end
for i = indexKept
        InfDS.OMEGAb(1+(i-1)*Nb:i*Nb,1+(i-1)*Nb:i*Nb) = OMEGAb(1+(i-1)*Nb:i*Nb,1+(i-1)*Nb:i*Nb);
end
end  %Nkept > 0
if Nkept < InfDS.Nsubj
   	InfDS.b(cindexKept,1:Nb) = oldb(cindexKept,1:Nb);    
	InfDS.Xtild(:,cindexKept,:) = xtild(:,cindexKept,:);
	
for i = cindexKept
		InfDS.dXtildthetafAll{i} = dXtilddthetafAll{i};
		InfDS.dXtildthetafAll2{i} = dXtilddthetafAll2{i};        
       
end 
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if yesMean ==1
    meanb = meanb + InfDS.b;
end

if (useMultN==1)
    InfDS.N = 1;
end

end
