%function [score,infoMat] =  getScoreInfoInov2(Xh_ekf, Xh_pred, P_ekf, xk1,xk2,xk3,xk4, InfDS,dxstardthetafAll,dxstardthetafAll2,isInfo,isDivideN,isDivideT)
function [score,infoMat] =  getScoreInfoInov2(Xh_ekf, Xh_pred, P_ekf, InfDS,dxstardthetafAll,dxstardthetafAll2,isDivideN,isDivideT)

SIndex = reshape(1:InfDS.Ny^2,InfDS.Ny,InfDS.Ny);
SIndex2 = reshape(1:(InfDS.Ny^2*InfDS.Ny),InfDS.Ny,InfDS.Ny^2);
LIndex = reshape(1:(InfDS.Nx*InfDS.Ny),InfDS.Ny,InfDS.Nx);




if InfDS.Nbeta > 0
    dlikdBetaAll = zeros(InfDS.Nbeta,1);
    dlikdBetaAll2 = zeros(InfDS.Nbeta,InfDS.Nbeta);
end

if InfDS.Nmu > 0
    dlikdmuAll = zeros(InfDS.Nmu,1);
    dlikdmuAll2 = zeros(InfDS.Nmu,InfDS.Nmu);
end

if InfDS.NLambda > 0
    dlikdLambdaAll = zeros(InfDS.NLambda,1);
    dlikdLambdaAll2 = zeros(InfDS.NLambda,InfDS.NLambda);
end

dlikdEpsilonAll = zeros(InfDS.Ny,1);
dlikdEpsilonAll2 = zeros(InfDS.Ny,InfDS.Ny);

if InfDS.Neta > 0
    dlikdEtaAll = zeros(InfDS.Neta,1);
    dlikdEtaAll2 = zeros(InfDS.Neta,InfDS.Neta);
    
end
if InfDS.Nb > 0
    dlikdbAll = zeros(InfDS.Nbpar,1);
    dlikdbAll2 = zeros(InfDS.Nbpar,InfDS.Nbpar);
    ivSigmab = inv(InfDS.Sigmab);
end


infoMat = zeros(length(InfDS.par),length(InfDS.par));
ivSigmae2 = diag(1./diag(InfDS.Sigmae));
%tspan = 0:InfDS.delt:InfDS.maxT;
%tspan = round2(tspan,InfDS.delt);

for i=1:InfDS.Nsubj
    T = InfDS.allT(i);%InfDS.allT(i)=length(InfDS.timeDiscrete{i}) only at observed
    Deltati = round2(InfDS.Deltat{i},InfDS.delt);
    
    
    if InfDS.Nbetax > 0
        Lambda = zeros(InfDS.Ny,InfDS.Nx);
        Lambda(:,1:InfDS.NxState) = InfDS.Lambda;
    else
        Lambda = InfDS.Lambda;
    end
    
    dXh_ekf = zeros(InfDS.Nx,T); dXh_pred = zeros(InfDS.Nx,T);
    for j=1:InfDS.Nx
        dXh_ekf(j,:) =  [0, diff(reshape(Xh_ekf(j,i,1:T),1,T))] ;
        dXh_pred(j,:) = [0, diff(reshape(Xh_pred(j,i,1:T),1,T))];
    end
    
    inov2 = InfDS.Y{i}(:,1:T) - (kron(ones(1,T),InfDS.mu) + Lambda*reshape(Xh_ekf(:,i,1:T),InfDS.Nx,T));
    e = reshape(dXh_ekf - dXh_pred,InfDS.Nx,T);
    
    mulp = 1;
    if isDivideT==1
        mulp = T;
    end
    mulp2 = 1;
    if isDivideN ==1
        mulp2 = InfDS.Nsubj;
    end
  
    
    dxstardthetaf = dxstardthetafAll{i};
    dxstardthetaf2 = dxstardthetafAll2{i};
    
    
    for t=1:T
        
        SigmaEtat = Deltati(t)^6*(InfDS.G*InfDS.SigmaEta*InfDS.G');%P_ekf(1:InfDS.NxState,1:InfDS.NxState,i,t);
        [R,flag] = chol(SigmaEtat);
        et = e(:,t);
        inov2t = inov2(:,t);
        indexY = 1:InfDS.Ny;
        Ny = length(InfDS.Y{i}(~isnan(InfDS.Y{i}(:,t))&~isinf(inov2t)&~isnan(inov2t),t));
        indexY = indexY(~isnan(InfDS.Y{i}(:,t))&~isinf(inov2t)&~isnan(inov2t));
        if (~isempty(indexY) && length(InfDS.Y{i}(isnan(InfDS.Y{i}(:,t)),t)) < InfDS.Ny)%Not all indicators are missing
            
            
            if (InfDS.Neta > 0 && flag==0)
                ivSigmaEtat = inv(Deltati(t)^6*SigmaEtat);
                dlik=.5*(Deltati(t)^6*InfDS.dSigmaEtadEta*(kron(ivSigmaEtat,ivSigmaEtat)*reshape(et*et'-SigmaEtat,InfDS.Nx^2,1)));
                
                
                dlik2 = .5*kron(reshape(SigmaEtat\et*et'/SigmaEtat,1,InfDS.Nx^2),eye(InfDS.Neta))*Deltati(t)^6*InfDS.dSigmaEtadEta2...
                    -Deltati(t)^6*InfDS.dSigmaEtadEta*(kron(ivSigmaEtat,SigmaEtat\et*et'/SigmaEtat))*Deltati(t)^6*InfDS.dSigmaEtadEta'...
                    -.5*kron(reshape(ivSigmaEtat,1,InfDS.Nx^2),eye(InfDS.Neta))*Deltati(t)^6*InfDS.dSigmaEtadEta2...
                    +.5*Deltati(t)^6*InfDS.dSigmaEtadEta*kron(ivSigmaEtat,ivSigmaEtat)*Deltati(t)^6*InfDS.dSigmaEtadEta';
                
                dlikdEtaAll = dlikdEtaAll+~(isnan(dlik)&~isinf(dlik)).*dlik/mulp;
                dlikdEtaAll2 = dlikdEtaAll2 + (~isnan(dlik2)&~isinf(dlik2)).*dlik2/mulp;
            end
            
            if (InfDS.Nbeta > 0 &&flag==0 && max(isnan(reshape(P_ekf(:,:,i,t),InfDS.Nx^2,1)))==0 && max(reshape(P_ekf(:,:,i,t),InfDS.Nx^2,1)) < 1000 ) > 0
                
                
                dlik = InfDS.H((1+(i-1)*InfDS.Ntheta):(i*InfDS.Ntheta),:)'*dxstardthetaf(:,(1+(t-1)*InfDS.Nx):(t*InfDS.Nx))/SigmaEtat*et;
                vvv=kron(eye(InfDS.Nx),InfDS.H((1+(i-1)*InfDS.Ntheta):(i*InfDS.Ntheta),:)');
                dlik2 = kron(et'/SigmaEtat,eye(InfDS.Nbeta))*vvv*dxstardthetaf2((1+(t-1)*InfDS.Ntheta*InfDS.Nx):(t*InfDS.Ntheta*InfDS.Nx),:)*InfDS.H((1+(i-1)*InfDS.Ntheta):(i*InfDS.Ntheta),:)-InfDS.H((1+(i-1)*InfDS.Ntheta):(i*InfDS.Ntheta),:)'*dxstardthetaf(:,(1+(t-1)*InfDS.Nx):(t*InfDS.Nx))/SigmaEtat*dxstardthetaf(:,(1+(t-1)*InfDS.Nx):(t*InfDS.Nx))'*InfDS.H((1+(i-1)*InfDS.Ntheta):(i*InfDS.Ntheta),:);
                dlikdBetaAll = dlikdBetaAll+ (~isnan(dlik)&~isinf(dlik)).*dlik/mulp;
                dlikdBetaAll2 = dlikdBetaAll2+ (~isnan(dlik2)&~isinf(dlik2)).*dlik2/mulp;
            end
            
            if InfDS.Nmu > 0
                dlik = (InfDS.dmudparMu*ivSigmae2*inov2t);
                dlik2 = (kron(inov2t'*ivSigmae2,eye(InfDS.Nmu))*InfDS.dmudparMu2 - InfDS.dmudparMu*ivSigmae2*InfDS.dmudparMu');
                dlikdmuAll(indexY) = dlikdmuAll(indexY) + dlik(indexY)/mulp;
                dlikdmuAll2(indexY,indexY) = dlikdmuAll2(indexY,indexY)+  dlik2(indexY,indexY)/mulp;
            end
            
            
            dlik = (.5*InfDS.dSigmaede(indexY,reshape(SIndex(indexY,indexY),1,Ny^2))*(kron(ivSigmae2(indexY,indexY),ivSigmae2(indexY,indexY))*reshape(inov2t(indexY)*inov2t(indexY)'-InfDS.Sigmae(indexY,indexY),Ny^2,1)));
            
            a = reshape(SIndex(indexY,indexY),1,Ny^2);
            dlik2 = (.5*kron(reshape(ivSigmae2(indexY,indexY)*(inov2t(indexY)*inov2t(indexY)')*ivSigmae2(indexY,indexY),1,Ny^2),eye(Ny))*InfDS.dSigmaede2(reshape(SIndex2(indexY,a),1,Ny*Ny^2),indexY)-InfDS.dSigmaede(indexY,reshape(SIndex(indexY,indexY),1,Ny^2))*(kron(ivSigmae2(indexY,indexY),ivSigmae2(indexY,indexY)*(inov2t(indexY)*inov2t(indexY)')*ivSigmae2(indexY,indexY)))*InfDS.dSigmaede(indexY,reshape(SIndex(indexY,indexY),1,Ny^2))'-.5*(kron(reshape(ivSigmae2(indexY,indexY),1,Ny^2),eye(Ny))*InfDS.dSigmaede2(reshape(SIndex2(indexY,a),1,Ny*Ny^2),indexY))+.5*(InfDS.dSigmaede(indexY,reshape(SIndex(indexY,indexY),1,Ny^2))*kron(ivSigmae2(indexY,indexY),ivSigmae2(indexY,indexY))*InfDS.dSigmaede(indexY,reshape(SIndex(indexY,indexY),1,Ny^2))'));
            
            
            dlikdEpsilonAll(indexY) = dlikdEpsilonAll(indexY)+ (~isnan(dlik)&~isinf(dlik)).*dlik/mulp;
            dlikdEpsilonAll2(indexY,indexY) = dlikdEpsilonAll2(indexY,indexY) + (~isnan(dlik2)&~isinf(dlik2)).*dlik2/mulp;
            
            
            if InfDS.NLambda > 0
                indexY2 = indexY(indexY>1);
                
                
                a = reshape(LIndex(indexY,:),1,Ny*InfDS.Nx);
                dlik = (InfDS.dLambdparLamb(indexY(indexY>1)-1,a)*reshape(ivSigmae2(indexY,indexY)*inov2t(indexY)*Xh_ekf(:,i,t)',Ny*InfDS.Nx,1));
                dlik2 = (-InfDS.dLambdparLamb(indexY(indexY>1)-1,a)*(kron(Xh_ekf(:,i,t)*Xh_ekf(:,i,t)',ivSigmae2(indexY,indexY)))*InfDS.dLambdparLamb(indexY(indexY>1)-1,a)');
                
                %Don't need this part because InfDS.dLambdaparLambd2 = 0. If not, add it
                %back to dlik2
                %NLambda = length(indexY(indexY>1));
                %a2 = reshape(LIndex2(indexY2-1,:),1,Ny*InfDS.Nx*NLambda);
                %+kron(reshape(ivSigmae2(indexY,indexY)*inov2t(indexY)*Xh_ekf(:,i,t)',1,Ny*InfDS.Nx),eye(NLambda))*InfDS.dLambdaparLambd2(a2,indexY2-1)
                
                
                dlikdLambdaAll(indexY2-1) =  dlikdLambdaAll(indexY2-1) + (~isnan(dlik)&~isinf(dlik)).*dlik/mulp;
                dlikdLambdaAll2((indexY2-1),(indexY2-1)) = dlikdLambdaAll2(indexY2-1,indexY2-1)+ (~isnan(dlik2)&~isinf(dlik2)).*dlik2/mulp;
                
            end
            
            
        end %end of if then check if all Nys are missing at time t.
    end %end of T loop
    
    if InfDS.Nb > 0
        b = reshape(InfDS.b(i,:),InfDS.Nb,1);
        dlik = (.5*InfDS.dSigmabdb*(kron(ivSigmab,ivSigmab)*reshape(b*b'-InfDS.Sigmab,InfDS.Nb^2,1)));
        dlik2 = (.5*kron(reshape(ivSigmab*b*b'*ivSigmab,1,InfDS.Nb^2),eye(InfDS.Nbpar))*InfDS.dSigmabdb2-InfDS.dSigmabdb*(kron(ivSigmab,ivSigmab*b*b'*ivSigmab))*InfDS.dSigmabdb'-.5*kron(reshape(ivSigmab,1,InfDS.Nb^2),eye(InfDS.Nbpar))*InfDS.dSigmabdb2+.5*InfDS.dSigmabdb*kron(ivSigmab,ivSigmab)*InfDS.dSigmabdb');
        
        dlikdbAll = dlikdbAll+ (~isnan(dlik)&~isinf(dlik)).*dlik/mulp2;
        dlikdbAll2 = dlikdbAll2+ (~isnan(dlik2)&~isinf(dlik2)).*dlik2/mulp2;
        
    end
    
    
end%end of subject loop

score=[];
curpos2 = 0;
if InfDS.Nbeta  > 0
    score = dlikdBetaAll;
    curpos1 = 1; curpos2 = curpos2+InfDS.Nbeta;
    infoMat(curpos1:curpos2,curpos1:curpos2) = dlikdBetaAll2;
end

if InfDS.Nmu > 0
    score = [score; dlikdmuAll];
    curpos1 = curpos2+1; curpos2 = curpos2+InfDS.Nmu;
    infoMat(curpos1:curpos2,curpos1:curpos2) = dlikdmuAll2;
end

if InfDS.NLambda > 0
    score = [score; dlikdLambdaAll];
    curpos1 = curpos2+1; curpos2 = curpos2+InfDS.NLambda;
    infoMat(curpos1:curpos2,curpos1:curpos2)=dlikdLambdaAll2;
end

score = [score;dlikdEpsilonAll];
curpos1 = curpos2+1; curpos2 = curpos2+InfDS.Ny;
infoMat(curpos1:curpos2,curpos1:curpos2)=dlikdEpsilonAll2;


if InfDS.Neta > 0
    score = [score;dlikdEtaAll];
    curpos1 = curpos2+1; curpos2 = curpos2+InfDS.Neta;
    infoMat(curpos1:curpos2,curpos1:curpos2)=dlikdEtaAll2;
end

if InfDS.Nb > 0
    score = [score; dlikdbAll];
    curpos1 = curpos2+1; curpos2 = curpos2+InfDS.Nbpar;
    infoMat(curpos1:curpos2,curpos1:curpos2) = dlikdbAll2;
end



infoMat = -1*infoMat;

end

