function r = dfdxFixedIC(xin,InfDS,i,t)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% The van der Pol oscillator equations in vector form
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

y = xin;

omega = InfDS.omega;


if size(y,2) > 1
r = zeros(InfDS.Nx,InfDS.Nx,size(y,2));
else
r = zeros(InfDS.Nx,InfDS.Nx);
end


par = InfDS.par(1:InfDS.Nbeta);
%par = InfDS.dynpar;


if ~isempty(i)
pari = kron(ones(1,size(y,2)),InfDS.H((1+(i-1)*InfDS.Ntheta):(i*InfDS.Ntheta),:)*reshape(par,InfDS.Nbeta,1));    
else
pari = kron(reshape(InfDS.H*reshape(par,InfDS.Nbeta,1),InfDS.Ntheta,InfDS.Nsubj),ones(1,InfDS.N));    
end



%size(pari)


b = zeros(size(pari));
if (InfDS.Nb > 0)
if ~isempty(i) %Only for one subject, but may have t > 1
b(1:InfDS.Ntheta,:) = kron(ones(1,size(y,2)),InfDS.Z*reshape(InfDS.b(i,:),InfDS.Nb,1));    
elseif mod(size(y,2),InfDS.Nsubj)==0 %for more than one subject but one t
b = InfDS.Z*InfDS.b'; 
%b = kron(reshape(b,InfDS.Nb,InfDS.Nsubj),ones(1,InfDS.N));    
else %for more than one subject and more than one t
   bb = InfDS.Z*InfDS.b';    
   bb = kron(bb,ones(1,max(InfDS.lens)));
   b = bb(:,InfDS.Tfilter==1);        
end
end


pari = pari+b;


%x in rows, f in columns
if size(y,2) > 1 
    r(2,1,:) = ones(1,size(y,2));
    r(1,2,:) = - omega*ones(1,size(y,2)) - 2*y(1,:).*y(2,:).*pari(1,:);
    r(2,2,:) = pari(1,:).*(ones(1,size(y,2)) - y(1,:).^2);
else
    r(2,1) = 1;
    r(1,2) = - omega - 2*y(1)*y(2)*pari(1);
    r(2,2) = pari(1)*(1-y(1)^2);
end


end

