function r = dynfunIC(xin,isCell,InfDS,i,t,isStart)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% The van der Pol oscillator equations in vector form
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

omega = InfDS.omega;


y = xin;
if (isCell==1),
r = cell(InfDS.Nx,1);
else 
r = y;
end;


par = InfDS.par(1:InfDS.Nbeta);

if ~isempty(i)
pari = kron(ones(1,size(y,2)),InfDS.H((1+(i-1)*InfDS.Ntheta):(i*InfDS.Ntheta),:)*reshape(par,InfDS.Nbeta,1));    %InfDS.H, covariates
else
pari = kron(reshape(InfDS.H*reshape(par,InfDS.Nbeta,1),InfDS.Ntheta,InfDS.Nsubj),ones(1,InfDS.N));    
end



%size(pari)


b = zeros(size(pari));
if (InfDS.Nb > 0)
if ~isempty(i) %Only for one subject, but may have t > 1
b(1:InfDS.Ntheta,:) = kron(ones(1,size(y,2)),InfDS.Z*reshape(InfDS.b(i,:),InfDS.Nb,1));    
elseif mod(size(y,2),InfDS.Nsubj)==0 %for more than one subject but one t
b = InfDS.Z*InfDS.b'; 
%b = kron(reshape(b,InfDS.Nb,InfDS.Nsubj),ones(1,InfDS.N));    
else %for more than one subject and more than one t
   bb = InfDS.Z*InfDS.b';    
   bb = kron(bb,ones(1,max(InfDS.lens)));
   b = bb(:,InfDS.Tfilter==1);        
end
end


pari = pari+b;


if (isCell==1),
if isStart==1
    r{1} = pari(2,:);
    r{2} = pari(3,:);
else
r{1} = cell2mat(y{2})';
r{2} = -omega*cell2mat(y{1})' +pari(1,:).*(1-cell2mat(y{1})'.^2).*cell2mat(y{2})';
end

else %!isCell
if isStart==1
    r(1,:) = pari(2,:);
    r(2,:) = pari(3,:);
else
r(1,:) = y(2,:);
r(2,:) = -omega*y(1,:) +pari(1,:).*(1-y(1,:).^2).*y(2,:);    
end
end


end


