function [InfDS] = setParsFreeICwb(InfDS)
 

InfDS.par = real(InfDS.par);
%if InfDS.Nbeta > 0
%InfDS.runpar = InfDS.par(1:InfDS.Nbeta);
%InfDS.runpar(1) = exp(InfDS.runpar(1));
%end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Model specification: modify based on fitted model
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
InfDS.mu = zeros(InfDS.Ny,1);
if InfDS.Nmu > 0
startM = InfDS.Nbeta+1;
InfDS.mu = [InfDS.par(startM);InfDS.par(startM+1);InfDS.par(startM+2)];
InfDS.dmudparMu = eye(InfDS.Ny); %dmu/dtheta_mu
InfDS.dmudparMu2 = zeros(InfDS.Ny^2,InfDS.Ny);
end

if InfDS.NLambda > 0
startL = InfDS.Nbeta+ InfDS.Nmu+1;
InfDS.Lambda= [1 0; InfDS.par(startL) 0; InfDS.par(startL+1) 0];

InfDS.dLambdparLamb = zeros(InfDS.NLambda,InfDS.Ny*InfDS.Nx);
InfDS.dLambdparLamb(1,2) = 1;
InfDS.dLambdparLamb(2,3) = 1;
InfDS.dLambdaparLambd2 = zeros(InfDS.Nx*InfDS.Ny*InfDS.NLambda,InfDS.NLambda);
end

starte = InfDS.Nbeta+InfDS.Nmu+InfDS.NLambda+1;

%if exp(InfDS.par(starte))==0, InfDS.par(starte) = log(10e-4);end
%if exp(InfDS.par(starte+1))==0, InfDS.par(starte+1) = log(10e-4);end
%if exp(InfDS.par(starte+2))==0, InfDS.par(starte+2) = log(10e-4);end


InfDS.Sigmae = diag([exp(InfDS.par(starte)), exp(InfDS.par(starte+1)), exp(InfDS.par(starte+2))]);
InfDS.dSigmaede = [exp(InfDS.par(starte)) 0 0 0 0 0 0 0 0;
                  0 0 0 0 exp(InfDS.par(starte+1)) 0 0 0 0;
                  0 0 0 0 0 0 0 0 exp(InfDS.par(starte+2))];%dvec(Sigmae)/dtheta_e
                                 
InfDS.dSigmaede2 = zeros(InfDS.Ny^2*InfDS.Ny,InfDS.Ny);
InfDS.dSigmaede2(1,1) = exp(InfDS.par(starte));
InfDS.dSigmaede2(14,2) = exp(InfDS.par(starte+1));
InfDS.dSigmaede2(27,3) = exp(InfDS.par(starte+2));




if InfDS.Nb > 0         
startb = InfDS.Nbeta+InfDS.Nmu+InfDS.NLambda+InfDS.Ny+1;    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%Sigmab looks like this currently with the LDL' decomposition:
%[      exp(par1),          0,                   0]
%[      0,          exp(par2),      par4*exp(par2)]
%[      0,          par4*exp(par2), exp(par2)*par4^2 + exp(par3)]
%syms par1 par2 par3 par4 real;
%D = diag([exp(par1),exp(par2),exp(par3)]);
%L = [1 0 0;
%     0 1 0;
%     0 par4 1];
%f1 = exp(par1); f2 = exp(par2); f3 = par4*exp(par2); f4 = exp(par2)*par4^2 + exp(par3);
%vec(InfDS.SigmaEta) = [f1, 0,0,0,f2, f3, 0, f3, f4]'
%dQ1 = [diff(f1,par1) 0,0,0,diff(f2,par1), diff(f3,par1),0, diff(f3,par1),diff(f4,par1);
%    diff(f1,par2) 0,0,0,diff(f2,par2), diff(f3,par2),0, diff(f3,par2),diff(f4,par2);
%    diff(f1,par3) 0,0,0,diff(f2,par3), diff(f3,par3),0, diff(f3,par3),diff(f4,par3);
%    diff(f1,par4) 0,0,0,diff(f2,par4), diff(f3,par4),0, diff(f3,par4),diff(f4,par4)];
%dQ2 = reshape(dQ1,InfDS.Nb^2*InfDS.Nbpar,1);
%[reshape(1:InfDS.Nb^2*InfDS.Nbpar,InfDS.Nb^2*InfDS.Nbpar,1) diff(dQ2,par1) diff(dQ2,par2) diff(dQ2,par3) diff(dQ2,par4)]
%%%%%%%

if exp(InfDS.par(startb))==0, InfDS.par(startb) = log(10e-7);end
if exp(InfDS.par(startb+1))==0, InfDS.par(startb+1) = log(10e-7);end
D = diag(exp(InfDS.par(startb:(startb+InfDS.Nbpar-2))));
L = [1 0 0;
     0 1 0;
     0 InfDS.par(startb+3) 1];
InfDS.Sigmab = L*D*L';
InfDS.dSigmabdb = zeros(InfDS.Nbpar,InfDS.Nb^2);
InfDS.dSigmabdb2 = zeros(InfDS.Nbpar*InfDS.Nb^2,InfDS.Nbpar);

InfDS.dSigmabdb(1,1) = exp(InfDS.par(startb));
InfDS.dSigmabdb(2,5) =  exp(InfDS.par(startb+1));
InfDS.dSigmabdb(2,6) = InfDS.par(startb+3)*exp(InfDS.par(startb+1));
InfDS.dSigmabdb(2,8) = InfDS.par(startb+3)*exp(InfDS.par(startb+1));
InfDS.dSigmabdb(2,9) = InfDS.par(startb+3)^2*exp(InfDS.par(startb+1));


InfDS.dSigmabdb(3,9) = exp(InfDS.par(startb+2));
InfDS.dSigmabdb(4,6) = exp(InfDS.par(startb+1));
InfDS.dSigmabdb(4,8) = exp(InfDS.par(startb+1));
InfDS.dSigmabdb(4,9) = 2*InfDS.par(startb+3)*exp(InfDS.par(startb+1));


InfDS.dSigmabdb2(1,1) = exp(InfDS.par(startb));
InfDS.dSigmabdb2(18,2) = exp(InfDS.par(startb+1));
InfDS.dSigmabdb2(22,2) = InfDS.par(startb+3)*exp(InfDS.par(startb+1));
InfDS.dSigmabdb2(22,4) = exp(InfDS.par(startb+1));
InfDS.dSigmabdb2(24,2) = exp(InfDS.par(startb+1));
InfDS.dSigmabdb2(30,2) = InfDS.par(startb+3)*exp(InfDS.par(startb+1));
InfDS.dSigmabdb2(30,4) = exp(InfDS.par(startb+1));
InfDS.dSigmabdb2(32,2) = exp(InfDS.par(startb+1));
InfDS.dSigmabdb2(34,2) = (InfDS.par(startb+3))^2*exp(InfDS.par(startb+1));
InfDS.dSigmabdb2(34,4) = 2*(InfDS.par(startb+3))*exp(InfDS.par(startb+1));
InfDS.dSigmabdb2(35,3) = exp(InfDS.par(startb+2));
InfDS.dSigmabdb2(36,2) = 2*(InfDS.par(startb+3))*exp(InfDS.par(startb+1));
InfDS.dSigmabdb2(36,4) = 2*exp(InfDS.par(startb+1));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
end %End of Nb > 0


end
